Skip to main content

Get container raw events

Retrieves the raw event data for a container by its ID. Raw events provide the most detailed event information available, including original event descriptions from carrier systems. Get a list of past and future (estimated) milestones for a container as reported by the carrier. For past events we recommend consuming transport_events.

Endpoint Overview

GET /containers/{id}/raw_events This endpoint returns comprehensive raw event data with timestamps, locations, vessel information, and original event descriptions.

Request Format

Headers

HeaderTypeRequiredDescription
X-API-KeystringYesYour API key for authentication

Path Parameters

ParameterTypeRequiredDescription
idstringYesThe unique identifier of the container

Response Format

Success Response (200 OK)

{
  "data": [
    {
      "id": "ca6b760f-13e9-4bf6-ab49-3cf2e40757fb",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-03-03T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-03-03",
        "estimated_at": null,
        "actual_at": null,
        "event": "empty_out",
        "index": 0,
        "original_event": "Truck Gate out empty",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": null,
        "location_name": "Oakland",
        "location_locode": null,
        "vessel_name": null,
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": null
        }
      }
    },
    {
      "id": "bcdfc796-0570-4c85-9336-d6c7d0da02d2",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-03-09T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-03-09",
        "estimated_at": null,
        "actual_at": null,
        "event": "full_in",
        "index": 1,
        "original_event": "Truck Arrival in",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": null,
        "location_name": null,
        "location_locode": null,
        "vessel_name": null,
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": null
        }
      }
    },
    {
      "id": "a4ff01b0-b374-4123-ae65-3dc0c7ea41ea",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-03-14T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-03-14",
        "estimated_at": null,
        "actual_at": null,
        "event": "vessel_loaded",
        "index": 2,
        "original_event": "Vessel Loaded",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "FA009R",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "MSC FAITH",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "4b473d0e-7073-4171-8b5b-15e71e9e13cc",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "ca5862ef-6e27-4245-a281-0cec6bbe1fb7",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-03-15T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-03-15",
        "estimated_at": null,
        "actual_at": null,
        "event": "vessel_departed",
        "index": 3,
        "original_event": "Vessel departed",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "FA009R",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "MSC FAITH",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "4b473d0e-7073-4171-8b5b-15e71e9e13cc",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "f47a903e-e6d1-41c5-aec6-8401b2abf297",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-03-25T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-03-25",
        "estimated_at": null,
        "actual_at": null,
        "event": "transshipment_arrived",
        "index": 4,
        "original_event": "Vessel arrived",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "FA009R",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "MSC FAITH",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "4b473d0e-7073-4171-8b5b-15e71e9e13cc",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "72a1a13b-a2e0-4ac0-851d-eec41e9e9087",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-03-25T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-03-25",
        "estimated_at": null,
        "actual_at": null,
        "event": "transshipment_discharged",
        "index": 5,
        "original_event": "Vessel Discharged",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "FA009R",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "MSC FAITH",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "4b473d0e-7073-4171-8b5b-15e71e9e13cc",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "cd91f0cf-ee73-4c47-b99f-63245cb5bc96",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-04-07T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-04-07",
        "estimated_at": null,
        "actual_at": null,
        "event": "transshipment_loaded",
        "index": 6,
        "original_event": "Vessel Loaded",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "15W10",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "SINGAPORE EXPRESS",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "345c05ab-4217-4ffe-a1a4-6c03b9ad2b36",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "561dbb7e-c3ab-4e63-b09b-957878b1425f",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-04-07T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-04-07",
        "estimated_at": null,
        "actual_at": null,
        "event": "transshipment_departed",
        "index": 7,
        "original_event": "Vessel departed",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "15W10",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "SINGAPORE EXPRESS",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "345c05ab-4217-4ffe-a1a4-6c03b9ad2b36",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "551711a6-62ad-4205-8da2-00e0c0cbd2db",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-04-12T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-04-12",
        "estimated_at": null,
        "actual_at": null,
        "event": "vessel_arrived",
        "index": 8,
        "original_event": "Vessel arrived",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "15W10",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "SINGAPORE EXPRESS",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "345c05ab-4217-4ffe-a1a4-6c03b9ad2b36",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "f4027470-75ca-4e2a-b4f0-47654a25ac48",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-04-13T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-04-13",
        "estimated_at": null,
        "actual_at": null,
        "event": "vessel_discharged",
        "index": 9,
        "original_event": "Vessel Discharged",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": "15W10",
        "location_name": null,
        "location_locode": null,
        "vessel_name": "SINGAPORE EXPRESS",
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": {
            "id": "345c05ab-4217-4ffe-a1a4-6c03b9ad2b36",
            "type": "vessel"
          }
        }
      }
    },
    {
      "id": "50f11e4f-411e-48e2-8141-64226500df9c",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-04-14T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-04-14",
        "estimated_at": null,
        "actual_at": null,
        "event": "full_out",
        "index": 10,
        "original_event": "Truck Departure from",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": null,
        "location_name": null,
        "location_locode": null,
        "vessel_name": null,
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": null
        }
      }
    },
    {
      "id": "49aea23c-b8c5-4a97-b133-f7a9723fa1b4",
      "type": "raw_event",
      "attributes": {
        "timestamp": "2020-04-15T00:00:00Z",
        "estimated": false,
        "actual_on": "2020-04-15",
        "estimated_at": null,
        "actual_at": null,
        "event": "empty_in",
        "index": 11,
        "original_event": "Truck Gate in empty",
        "created_at": "2020-04-18T00:18:27Z",
        "voyage_number": null,
        "location_name": null,
        "location_locode": null,
        "vessel_name": null,
        "vessel_imo": null,
        "timezone": null
      },
      "relationships": {
        "location": {
          "data": null
        },
        "vessel": {
          "data": null
        }
      }
    }
  ],
  "included": [
    {
      "id": "4b473d0e-7073-4171-8b5b-15e71e9e13cc",
      "type": "vessel",
      "attributes": {
        "name": "MSC FAITH",
        "imo": null,
        "mmsi": "636019213",
        "latitude": 70.22625823437389,
        "longitude": 45.06279126658865,
        "nautical_speed_knots": 100,
        "navigational_heading_degrees": 1,
        "position_timestamp": "2023-06-05T19:46:18Z"
      }
    },
    {
      "id": "345c05ab-4217-4ffe-a1a4-6c03b9ad2b36",
      "type": "vessel",
      "attributes": {
        "name": "SINGAPORE EXPRESS",
        "imo": null,
        "mmsi": "477300500",
        "latitude": 70.22625823437389,
        "longitude": 45.06279126658865,
        "nautical_speed_knots": 100,
        "navigational_heading_degrees": 1,
        "position_timestamp": "2023-06-05T19:46:18Z"
      }
    }
  ]
}

Response Fields

FieldTypeDescription
data[].idstringUnique identifier for the raw event
data[].typestringResource type (always raw_event)
data[].attributes.timestampstringISO 8601 timestamp of the event
data[].attributes.estimatedbooleanWhether the event is estimated
data[].attributes.actual_onstring/nullEvent’s local calendar date (if available)
data[].attributes.estimated_atstring/nullTime the estimate was produced
data[].attributes.actual_atstring/nullExact actual timestamp (if available)
data[].attributes.eventstringNormalized event type (e.g., empty_out, full_in, vessel_loaded, vessel_departed, transshipment_arrived, transshipment_loaded, transshipment_departed, vessel_arrived, vessel_discharged)
data[].attributes.indexnumberSequence index of this event
data[].attributes.original_eventstring/nullOriginal carrier-provided event text
data[].attributes.created_atstringWhen this event record was created
data[].attributes.voyage_numberstring/nullVoyage number if applicable
data[].attributes.location_namestring/nullHuman-readable location name
data[].attributes.location_locodestring/nullUN/LOCODE of location
data[].attributes.vessel_namestring/nullName of vessel (if applicable)
data[].attributes.vessel_imostring/nullIMO number of vessel (if applicable)
data[].attributes.timezonestring/nullTimezone of the event timestamps
data[].relationships.location.dataobject/nullLinked location resource identifier
data[].relationships.vessel.dataobject/nullLinked vessel resource identifier

Event Types

Raw events include the following event types:
  • empty_out: Container emptied out
  • full_in: Container filled in
  • vessel_loaded: Container loaded onto vessel
  • vessel_departed: Vessel departed with container
  • transshipment_arrived: Container arrived at transshipment port
  • transshipment_loaded: Container loaded at transshipment
  • transshipment_departed: Container departed transshipment
  • vessel_arrived: Vessel arrived at destination
  • vessel_discharged: Container discharged from vessel
  • full_out: Container filled out
  • empty_in: Container emptied in

Status Codes

CodeDescription
200Raw events retrieved successfully
404Container not found
401Authentication failed - invalid API key
429Rate limit exceeded